From c0557ce2bf952f727ee3539a1bb7cab1a2088b3f Mon Sep 17 00:00:00 2001
From: Toshikazu Nakayama <nakayama.ts@ncos.nec.co.jp>
Date: Fri, 5 Nov 2010 15:02:20 +0900
Subject: [PATCH 1/4] Add percpu member.

Add module percpu in load_module and offset_table struct.
This is used for KMOD_V2.

[v3]
Add more staff for module percpu.
Their symbol space is moved into particular module in this version.

Signed-off-by: Toshikazu Nakayama <nakayama.ts@ncos.nec.co.jp>
---
 defs.h |    6 ++++++
 1 files changed, 6 insertions(+), 0 deletions(-)

diff --git a/defs.h b/defs.h
index dcece4a..4b77475 100755
--- a/defs.h
+++ b/defs.h
@@ -1090,6 +1090,7 @@ struct offset_table {                    /* stash of commonly-used offsets */
 	long module_num_symtab;
 	long module_symtab;
 	long module_strtab;
+	long module_percpu;
 
 	long module_kallsyms_start;
 	long kallsyms_header_sections;
@@ -2063,6 +2064,8 @@ struct load_module {
 	ulong mod_init_size;
 	struct syment *mod_init_symtable;
 	struct syment *mod_init_symend;
+	ulong mod_percpu;
+	ulong mod_percpu_size;
 };
 
 #define IN_MODULE(A,L) \
@@ -2071,6 +2074,9 @@ struct load_module {
 #define IN_MODULE_INIT(A,L) \
  (((ulong)(A) >= (L)->mod_init_module_ptr) && ((ulong)(A) < ((L)->mod_init_module_ptr+(L)->mod_init_size)))
 
+#define IN_MODULE_PCPU(A,L) \
+ (((ulong)(A) >= (L)->mod_percpu) && ((ulong)(A) < ((L)->mod_percpu+(L)->mod_percpu_size)))
+
 #ifndef GDB_COMMON
 
 #define KVADDR             (0x1)
-- 
1.7.3.2.161.g3089c

